## toil 4.0.0

=== Makefile ===
# Copyright (C) 2015-2018 UCSC Computational Genomics Lab
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
include common.mk

define help

Supported targets: prepare, develop, docs, sdist, clean, test, docker and push_docker.

Please note that all build targets require a virtualenv to be active.

The 'prepare' target installs Toil's build requirements into the current virtualenv.

The 'develop' target creates an editable install of Toil and its runtime requirements in the
current virtualenv. The install is called 'editable' because changes to the source code
immediately affect the virtualenv. Set the 'extras' variable to ensure that the 'develop' target
installs support for extras; some tests require extras to be installed. Consult setup.py for the
list of supported extras. To install Toil in develop mode with all extras, run

	make develop extras=[all]

The 'sdist' target creates a source distribution of Toil. It is used for some unit tests and for
installing the currently checked out version of Toil into the appliance image.

The 'clean' target cleans up the side effects of 'develop', 'sdist', 'docs', and 'docker'
on this machine. It does not undo externally visible effects like removing packages already
uploaded to PyPI.

The 'docs' target uses Sphinx to create HTML documentation in the docs/_build directory

Targets are provided to run Toil's tests. Note that these targets do *not* automatically install
Toil's dependencies; it is recommended to 'make develop' before running any of them.

The 'test' target runs Toil's unit tests serially with pytest. It will run some docker tests and
setup. Note: this target does not capture output from the terminal. For any of the test targets,
set the 'tests' variable to run a particular test, e.g.

	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort

The 'integration_test' target runs toil's integration tests. These are more thorough but also
more costly than the regular unit tests. For the AWS integration tests to run, the environment
variable 'TOIL_AWS_KEYNAME' must be set. This user will be charged for expenses accrued during the
test.

The 'docker' target builds the Docker images that make up the Toil appliance. You may set the
TOIL_DOCKER_REGISTRY variable to override the default registry that the 'push_docker' target pushes
the appliance images to, for example:

	TOIL_DOCKER_REGISTRY=quay.io/USER make docker

If Docker is not installed, Docker-related targets tasks and tests will be skipped. The
same can be achieved by setting TOIL_DOCKER_REGISTRY to an empty string.

The 'push_docker' target pushes the Toil appliance images to a remote Docker registry. It
requires the TOIL_DOCKER_REGISTRY variable to be set to a value other than the default to avoid
accidentally pushing to the official Docker registry for Toil.

The TOIL_DOCKER_NAME environment variable can be set to customize the appliance image name that
is created by the 'docker' target and pushed by the 'push_docker' target. The Toil team\'s
continuous integration system overrides this variable to avoid conflicts between concurrently
executing builds for the same revision, e.g. toil-pr and toil-it.

endef
export help
help:
	@printf "$$help"


# This Makefile uses bash features like printf and <()
SHELL=bash
python=python
pip=pip
tests=src
tests_local=src/toil/test
# do slightly less than travis timeout of 10 min.
pytest_args_local=-vv --timeout=530
extras=

sdist_name:=toil-$(shell $(python) version_template.py distVersion).tar.gz

green=\033[0;32m
normal=\033[0m
red=\033[0;31m
cyan=\033[0;36m

develop: check_venv
	$(pip) install -e .$(extras)

clean_develop: check_venv
	- $(pip) uninstall -y toil
	- rm -rf src/*.egg-info
	- rm src/toil/version.py

sdist: dist/$(sdist_name)

dist/$(sdist_name): check_venv
	@test -f dist/$(sdist_name) && mv dist/$(sdist_name) dist/$(sdist_name).old || true
	$(python) setup.py sdist
	@test -f dist/$(sdist_name).old \
	    && ( cmp -s <(tar -xOzf dist/$(sdist_name)) <(tar -xOzf dist/$(sdist_name).old) \
	         && mv dist/$(sdist_name).old dist/$(sdist_name) \
	         && printf "$(cyan)No significant changes to sdist, reinstating backup.$(normal)\n" \
	         || rm dist/$(sdist_name).old ) \
	    || true

clean_sdist:
	- rm -rf dist
	- rm src/toil/version.py

# We always claim to be Travis, so that local test runs will not skip Travis tests.
# Gitlab doesn't run tests via the Makefile.

# The auto-deployment test needs the docker appliance
test: check_venv check_build_reqs docker
	TRAVIS=true \
	    $(python) -m pytest --cov=toil $(pytest_args_local) $(tests)


# This target will skip building docker and all docker based tests
# these are our travis tests; rename?
test_offline: check_venv check_build_reqs
	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
	TOIL_SKIP_DOCKER=True \
	TRAVIS=true \
	    $(python) -m pytest $(pytest_args_local) $(tests_local)

ifdef TOIL_DOCKER_REGISTRY

docker_image:=$(TOIL_DOCKER_REGISTRY)/$(TOIL_DOCKER_NAME)

grafana_image:=$(TOIL_DOCKER_REGISTRY)/toil-grafana
prometheus_image:=$(TOIL_DOCKER_REGISTRY)/toil-prometheus
mtail_image:=$(TOIL_DOCKER_REGISTRY)/toil-mtail

define tag_docker
	@printf "$(cyan)Removing old tag $2. This may fail but that's expected.$(normal)\n"
	-docker rmi $2
	docker tag $1 $2
	@printf "$(green)Tagged appliance image $1 as $2.$(normal)\n"
endef

docker: docker/Dockerfile
	# Pre-pull everything
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:16.04 && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.0.0 && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull grafana/grafana && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull sscaling/mtail && break || sleep 60; done

	@set -ex \
	; cd docker \
	; docker build --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

	@set -ex \
	; cd dashboard/prometheus \
	; docker build --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

	@set -ex \
	; cd dashboard/grafana \
	; docker build --tag=$(grafana_image):$(TOIL_DOCKER_TAG) -f Dockerfile .

	@set -ex \
	; cd dashboard/mtail \
	; docker build --tag=$(mtail_image):$(TOIL_DOCKER_TAG) -f Dockerfile .


docker/$(sdist_name): dist/$(sdist_name)
	cp $< $@

docker/Dockerfile: docker/Dockerfile.py docker/$(sdist_name)
	_TOIL_SDIST_NAME=$(sdist_name) $(python) docker/Dockerfile.py > $@

clean_docker:
	-rm docker/Dockerfile docker/$(sdist_name)
	-docker rmi $(docker_image):$(TOIL_DOCKER_TAG)

push_docker: docker
	# Weird if logic is so we fail if all the pushes fail
	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(docker_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(grafana_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(prometheus_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(mtail_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done

else

docker docker_push clean_docker:
	@printf "$(cyan)Skipping '$@' target as TOIL_DOCKER_REGISTRY is empty or Docker is not installed.$(normal)\n"

endif


docs: check_venv check_build_reqs
	# Strange, but seemingly benign Sphinx warning floods stderr if not filtered:
	cd docs && make html

clean_docs: check_venv
	- cd docs && make clean

clean: clean_develop clean_sdist clean_docs

check_build_reqs:
	@($(python) -c 'import mock; import pytest' && which sphinx-build >/dev/null) \
		|| ( printf "$(red)Build requirements are missing. Run 'make prepare' to install them.$(normal)\n" ; false )

prepare: check_venv
	$(pip) install mock==1.0.1 pytest==4.3.1 pytest-cov==2.6.1 stubserver==1.0.1 pytest-timeout==1.3.3 \
	setuptools==45.3.0 'sphinx>=2.4.4,<3' cwltest mypy

check_venv:
	@$(python) -c 'import sys, os; sys.exit( int( 0 if "VIRTUAL_ENV" in os.environ else 1 ) )' \
		|| ( printf "$(red)A virtualenv must be active.$(normal)\n" ; false )

check_clean_working_copy:
	@printf "$(green)Checking if your working copy is clean ...$(normal)\n"
	@git diff --exit-code > /dev/null \
		|| ( printf "$(red)Your working copy looks dirty.$(normal)\n" ; false )
	@git diff --cached --exit-code > /dev/null \
		|| ( printf "$(red)Your index looks dirty.$(normal)\n" ; false )
	@test -z "$$(git ls-files --other --exclude-standard --directory)" \
		|| ( printf "$(red)You have untracked files:$(normal)\n" \
			; git ls-files --other --exclude-standard --directory \
			; false )

check_cpickle:
	# fail if cPickle.dump(s) called without HIGHEST_PROTOCOL
	# https://github.com/BD2KGenomics/toil/issues/1503
	! find src -iname '*.py' | xargs grep 'cPickle.dump' | grep --invert-match HIGHEST_PROTOCOL

.PHONY: help \
		prepare \
		check_cpickle \
		develop clean_develop \
		sdist clean_sdist \
		test test_offline \
		docs clean_docs \
		clean \
		check_venv \
		check_clean_working_copy \
		check_build_reqs \
		docker clean_docker push_docker

=== debian/changelog ===
toil (4.0.0-3) unstable; urgency=medium

  * Mark the autopkgtest as superficial. (Closes: #958574)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 06 May 2020 20:58:48 +0200

toil (4.0.0-2) unstable; urgency=medium

  * Add python3-distutils dependency, needed for python3-docker
  * debian/copyright: remove leading "./"

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 27 Apr 2020 15:55:22 +0200

toil (4.0.0-1) unstable; urgency=medium

  * New upstream version
  * Freshen our patches
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse
  * python3-chardet is no longer needed

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 06 Apr 2020 13:56:50 +0200

=== debian/tests/control ===
Tests: smoke-test
Depends: toil
Features: superficial

## toil 4.1.0

=== debian/changelog ===
toil (4.1.0-1) unstable; urgency=medium

  * New upstream version
  * Refreshed the patches
  * debhelper-compat 13 (routine-update)
  * Update patch metatdata

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 07 Aug 2020 17:14:01 +0200

=== debian/control ===
Source: toil
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-setuptools,
               python3-docker,
               python3-dill,
               python3-future,
               python3-pytest-xdist,
               cwltool,
               python3-distutils,
               python3-enlighten,
# documentation
               python3-urllib3,
               python3-sphinx
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/toil
Vcs-Git: https://salsa.debian.org/med-team/toil.git
Homepage: https://github.com/BD2KGenomics/toil
Rules-Requires-Root: no

Package: toil
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         python3-distutils,
         cwltool
Recommends: python3-boto,
            python3-boto3,
# for google cloud support
            python3-libcloud
# for mesos support, but needs python3-mesos first
#         python3-protobuf,
Suggests: docker.io | singularity-container | docker-ce,
          python3-azure,
          python3-azure-storage,
          python3-idna,
Provides: cwl-runner
#Suggests: python-toil-doc
Description: cross-platform workflow engine
 Toil is a scalable, efficient, cross-platform and easy-to-use workflow
 engine in pure Python.  It works with several well established load
 balancers like Slurm or the Sun Grid Engine.  Toil is also compatible with
 the Common Workflow Language (CWL) via the "toil-cwl-runner" interface, which
 this package make available via the Debian alternativess system under the
 alias "cwl-runner".

#Package: python-toil-doc
#Architecture: all
#Section: doc
#Depends: ${sphinxdoc:Depends}, ${misc:Depends}
#Description: cross-platform workflow engine (common documentation)
# The documentation of Toil shall go here at some point.
# .
# This is the common documentation package.

## toil 4.2.0

=== Makefile ===
--- 
+++ 
@@ -46,6 +46,12 @@
 set the 'tests' variable to run a particular test, e.g.
 
 	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort
+    
+The 'test_offline' target is similar, but runs on;y tests that don't need
+Internet or Docker by default. You can configure the tests it runs with the
+'tests_local' variable:
+
+    make test_offline tests_local=src/toil/test/src/threadingTest.py
 
 The 'integration_test' target runs toil's integration tests. These are more thorough but also
 more costly than the regular unit tests. For the AWS integration tests to run, the environment

=== debian/changelog ===
toil (4.2.0-1) unstable; urgency=medium

  * New upstream version
  * Remove unneeded no_virtualenv_to_create_manpages.patch; freshen remaining
    patches.
  * debian/tests/control: 'superficial' is a restriction, not a feature
  * Quiet a lintian false positive for repeated-path-segment

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 27 Aug 2020 11:26:41 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-dill,
                python3-future,
                python3-pytest-xdist,
-               cwltool,
+               cwltool (>= 3.0.20200807132242),
                python3-distutils,
                python3-enlighten,
 # documentation

=== debian/tests/control ===
Tests: smoke-test
Depends: toil
Restrictions: superficial

## toil 5.2.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2015-2018 UCSC Computational Genomics Lab
+# Copyright (C) 2015-2021 Regents of the University of California
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -15,7 +15,7 @@
 
 define help
 
-Supported targets: prepare, develop, docs, sdist, clean, test, docker and push_docker.
+Supported targets: prepare, develop, docs, sdist, clean, test, docker, and push_docker.
 
 Please note that all build targets require a virtualenv to be active.
 
@@ -47,16 +47,11 @@
 
 	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort
     
-The 'test_offline' target is similar, but runs on;y tests that don't need
-Internet or Docker by default. You can configure the tests it runs with the
-'tests_local' variable:
-
-    make test_offline tests_local=src/toil/test/src/threadingTest.py
-
-The 'integration_test' target runs toil's integration tests. These are more thorough but also
-more costly than the regular unit tests. For the AWS integration tests to run, the environment
-variable 'TOIL_AWS_KEYNAME' must be set. This user will be charged for expenses accrued during the
-test.
+The 'test_offline' target is similar, but runs only tests that don't need
+Internet or Docker by default.  The 'test_offline' target takes the same tests
+argument as the 'test' target.
+
+    make test_offline tests=src/toil/test/src/threadingTest.py
 
 The 'docker' target builds the Docker images that make up the Toil appliance. You may set the
 TOIL_DOCKER_REGISTRY variable to override the default registry that the 'push_docker' target pushes
@@ -72,9 +67,7 @@
 accidentally pushing to the official Docker registry for Toil.
 
 The TOIL_DOCKER_NAME environment variable can be set to customize the appliance image name that
-is created by the 'docker' target and pushed by the 'push_docker' target. The Toil team\'s
-continuous integration system overrides this variable to avoid conflicts between concurrently
-executing builds for the same revision, e.g. toil-pr and toil-it.
+is created by the 'docker' target and pushed by the 'push_docker' target.
 
 endef
 export help
@@ -84,15 +77,9 @@
 
 # This Makefile uses bash features like printf and <()
 SHELL=bash
-python=python
-pip=pip
-tests=src
-tests_local=src/toil/test
-# do slightly less than travis timeout of 10 min.
-pytest_args_local=-vv --timeout=530
+tests=src/toil/test
 extras=
-
-sdist_name:=toil-$(shell $(python) version_template.py distVersion).tar.gz
+sdist_name:=toil-$(shell python version_template.py distVersion).tar.gz
 
 green=\033[0;32m
 normal=\033[0m
@@ -100,10 +87,10 @@
 cyan=\033[0;36m
 
 develop: check_venv
-	$(pip) install -e .$(extras)
+	pip install -e .$(extras)
 
 clean_develop: check_venv
-	- $(pip) uninstall -y toil
+	- pip uninstall -y toil
 	- rm -rf src/*.egg-info
 	- rm src/toil/version.py
 
@@ -111,7 +98,7 @@
 
 dist/$(sdist_name): check_venv
 	@test -f dist/$(sdist_name) && mv dist/$(sdist_name) dist/$(sdist_name).old || true
-	$(python) setup.py sdist
+	python setup.py sdist
 	@test -f dist/$(sdist_name).old \
 	    && ( cmp -s <(tar -xOzf dist/$(sdist_name)) <(tar -xOzf dist/$(sdist_name).old) \
 	         && mv dist/$(sdist_name).old dist/$(sdist_name) \
@@ -124,12 +111,9 @@
 	- rm src/toil/version.py
 
 # We always claim to be Travis, so that local test runs will not skip Travis tests.
-# Gitlab doesn't run tests via the Makefile.
-
-# The auto-deployment test needs the docker appliance
-test: check_venv check_build_reqs docker
+test: check_venv check_build_reqs
 	TRAVIS=true \
-	    $(python) -m pytest --cov=toil $(pytest_args_local) $(tests)
+	    python -m pytest --cov=toil --durations=0 -s -r s $(tests)
 
 
 # This target will skip building docker and all docker based tests
@@ -138,7 +122,7 @@
 	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
 	TOIL_SKIP_DOCKER=True \
 	TRAVIS=true \
-	    $(python) -m pytest $(pytest_args_local) $(tests_local)
+	    python -m pytest -vv --timeout=530 --cov=toil $(tests)
 
 ifdef TOIL_DOCKER_REGISTRY
 
@@ -183,7 +167,7 @@
 	cp $< $@
 
 docker/Dockerfile: docker/Dockerfile.py docker/$(sdist_name)
-	_TOIL_SDIST_NAME=$(sdist_name) $(python) docker/Dockerfile.py > $@
+	_TOIL_SDIST_NAME=$(sdist_name) python docker/Dockerfile.py > $@
 
 clean_docker:
 	-rm docker/Dockerfile docker/$(sdist_name)
@@ -214,15 +198,14 @@
 clean: clean_develop clean_sdist clean_docs
 
 check_build_reqs:
-	@($(python) -c 'import mock; import pytest' && which sphinx-build >/dev/null) \
+	@(python -c 'import mock; import pytest' && which sphinx-build >/dev/null) \
 		|| ( printf "$(red)Build requirements are missing. Run 'make prepare' to install them.$(normal)\n" ; false )
 
 prepare: check_venv
-	$(pip) install mock==1.0.1 pytest==4.3.1 pytest-cov==2.6.1 stubserver==1.0.1 pytest-timeout==1.3.3 \
-	setuptools==45.3.0 'sphinx>=2.4.4,<3' cwltest mypy
+	pip install -r requirements-dev.txt
 
 check_venv:
-	@$(python) -c 'import sys, os; sys.exit( int( 0 if "VIRTUAL_ENV" in os.environ else 1 ) )' \
+	@python -c 'import sys, os; sys.exit( int( 0 if "VIRTUAL_ENV" in os.environ else 1 ) )' \
 		|| ( printf "$(red)A virtualenv must be active.$(normal)\n" ; false )
 
 check_clean_working_copy:
@@ -240,6 +223,29 @@
 	# fail if cPickle.dump(s) called without HIGHEST_PROTOCOL
 	# https://github.com/BD2KGenomics/toil/issues/1503
 	! find src -iname '*.py' | xargs grep 'cPickle.dump' | grep --invert-match HIGHEST_PROTOCOL
+
+PYSOURCES=$(shell find src -name '*.py') setup.py version_template.py
+
+# Linting and code style related targets
+## sorting imports using isort: https://github.com/timothycrosley/isort
+sort_imports: $(PYSOURCES)
+	isort -m VERTICAL $^
+	make format
+
+remove_unused_imports: $(PYSOURCES)
+	autoflake --in-place --remove-all-unused-imports $^
+	make format
+
+format: $(wildcard src/toil/cwl/*.py)
+	black $^
+
+mypy:
+	mypy --ignore-missing-imports --no-strict-optional \
+		--warn-redundant-casts --warn-unused-ignores \
+		$(CURDIR)/src/toil/cwl/cwltoil.py
+
+flake8: $(PYSOURCES)
+	flake8 --ignore=E501,W293,W291,E265,E302,E722,E126,E303,E261,E201,E202,W503,W504,W391,E128,E301,E127,E502,E129,E262,E111,E117,E306,E203,E231,E226,E741,E122,E251,E305,E701,E222,E225,E241,E305,E123,E121,E703,E704,E125,E402 $^
 
 .PHONY: help \
 		prepare \

=== debian/changelog ===
toil (5.2.0-5) unstable; urgency=high

  * debian/patches/test_with_less_memory: reduce default resource reqs
    for 32bit systems

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 10 Feb 2021 11:24:49 +0100

toil (5.2.0-4) unstable; urgency=high

  * autopkgtests: skip some s3 related tests.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 08 Feb 2021 08:29:12 +0100

toil (5.2.0-3) unstable; urgency=high

  * autopkgtests: add missing dependency on python3-stubserver

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 07 Feb 2021 13:58:57 +0100

toil (5.2.0-2) unstable; urgency=high

  * Enable toil-wdl-runner now that python3-wdlparse is in Debian.
  * Enabled running the the tests during the build!

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 07 Feb 2021 13:26:16 +0100

toil (5.2.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * Freshen patches
  * update some copyright info
  * The python module "wdlparse" is not yet packaged for Debian; disable
    toil-wdl-runner in this release.
  * debian/control: update the minimum version of cwltool required

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 24 Jan 2021 12:07:21 +0100

=== debian/control ===
--- 
+++ 
@@ -11,14 +11,20 @@
                python3-docker,
                python3-dill,
                python3-future,
-               python3-pytest-xdist,
-               cwltool (>= 3.0.20200807132242),
+               cwltool (>= 3.0.20201203173111),
                python3-distutils,
                python3-enlighten,
+               python3-wdlparse,
+               python3-pytest <!nocheck>,
+               python3-mock <!nocheck>,
+               python3-boto3 <!nocheck>,
+               python3-boto <!nocheck>,
+               python3-stubserver <!nocheck>,
+               rsync <!nocheck>,
 # documentation
                python3-urllib3,
                python3-sphinx
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
 Homepage: https://github.com/BD2KGenomics/toil
@@ -32,6 +38,8 @@
          cwltool
 Recommends: python3-boto,
             python3-boto3,
+# for WDL support
+            python3-wdlparse,
 # for google cloud support
             python3-libcloud
 # for mesos support, but needs python3-mesos first

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/

#export PYBUILD_DISABLE=test
export PYBUILD_DISABLE_python2=1
%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=$(CURDIR)/src $(MAKE) -C docs man

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py -k "not test_bioconda and not test_run_conformance and not testImportFtpFile and not ToilWdlIntegrationTest and not SortTest and not testCwlexample" {dir}/src/toil/test' \
		dh_auto_test
endif

# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#override_dh_auto_build:
#	dh_auto_build
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml docs/ build/html # HTML generator
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bman  docs/ build/man  # Manpage generator

override_dh_auto_clean:
	rm -rf .pybuild
	rm -rf docs/_build
	find . -name "*.pyc" -delete

=== debian/tests/control ===
Tests: smoke-test
Depends: toil, python3-wdlparse
Restrictions: superficial

Tests: run-unit-tests
Depends: toil, python3-wdlparse, python3-pytest, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver
Restrictions: allow-stderr, needs-internet

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

https://github.com/BD2KGenomics/toil/releases .*/archive/releases/@ANY_VERSION@@ARCHIVE_EXT@

## toil 5.5.0

=== Makefile ===
--- 
+++ 
@@ -47,9 +47,11 @@
 
 	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort
     
+The 'cov' variable can be set to '' to suppress the test coverage report.
+    
 The 'test_offline' target is similar, but runs only tests that don't need
-Internet or Docker by default.  The 'test_offline' target takes the same tests
-argument as the 'test' target.
+Internet or Docker by default.  The 'test_offline' target takes the same
+arguments as the 'test' target.
 
     make test_offline tests=src/toil/test/src/threadingTest.py
 
@@ -78,7 +80,11 @@
 # This Makefile uses bash features like printf and <()
 SHELL=bash
 tests=src/toil/test
+cov="--cov=toil"
 extras=
+# You can say make develop packages=xxx to install packages in the same Python
+# environemnt as Toil itself without creating dependency conflicts with Toil
+packages=
 sdist_name:=toil-$(shell python version_template.py distVersion).tar.gz
 
 green=\033[0;32m
@@ -87,7 +93,7 @@
 cyan=\033[0;36m
 
 develop: check_venv
-	pip install -e .$(extras)
+	pip install -e .$(extras) $(packages)
 
 clean_develop: check_venv
 	- pip uninstall -y toil
@@ -111,9 +117,10 @@
 	- rm src/toil/version.py
 
 # We always claim to be Travis, so that local test runs will not skip Travis tests.
+# Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
 test: check_venv check_build_reqs
-	TRAVIS=true \
-	    python -m pytest --cov=toil --durations=0 -s -r s $(tests)
+	TRAVIS=true TOIL_OWNER_TAG="shared" \
+	    python -m pytest --durations=0 --log-level DEBUG --log-cli-level INFO -r s $(cov) $(tests)
 
 
 # This target will skip building docker and all docker based tests
@@ -122,7 +129,7 @@
 	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
 	TOIL_SKIP_DOCKER=True \
 	TRAVIS=true \
-	    python -m pytest -vv --timeout=530 --cov=toil $(tests)
+	    python -m pytest -vv --timeout=530 --log-level DEBUG --log-cli-level INFO $(cov) $(tests)
 
 ifdef TOIL_DOCKER_REGISTRY
 
@@ -142,7 +149,7 @@
 docker: docker/Dockerfile
 	# Pre-pull everything
 	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:16.04 && break || sleep 60; done
-	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.0.0 && break || sleep 60; done
+	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.24.1 && break || sleep 60; done
 	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull grafana/grafana && break || sleep 60; done
 	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull sscaling/mtail && break || sleep 60; done
 
@@ -236,13 +243,18 @@
 	autoflake --in-place --remove-all-unused-imports $^
 	make format
 
+remove_trailing_whitespace:
+	$(CURDIR)/contrib/admin/remove_trailing_whitespace.py
+
 format: $(wildcard src/toil/cwl/*.py)
 	black $^
 
 mypy:
-	mypy --ignore-missing-imports --no-strict-optional \
-		--warn-redundant-casts --warn-unused-ignores \
-		$(CURDIR)/src/toil/cwl/cwltoil.py
+	$(CURDIR)/contrib/admin/mypy-with-ignore.py
+
+diff_mypy:
+	mypy --cobertura-xml-report . src/toil || true
+	diff-cover --fail-under=100 cobertura.xml
 
 flake8: $(PYSOURCES)
 	flake8 --ignore=E501,W293,W291,E265,E302,E722,E126,E303,E261,E201,E202,W503,W504,W391,E128,E301,E127,E502,E129,E262,E111,E117,E306,E203,E231,E226,E741,E122,E251,E305,E701,E222,E225,E241,E305,E123,E121,E703,E704,E125,E402 $^
@@ -255,6 +267,7 @@
 		test test_offline \
 		docs clean_docs \
 		clean \
+		format mypy sort_imports remove_unused_imports \
 		check_venv \
 		check_clean_working_copy \
 		check_build_reqs \

=== debian/changelog ===
toil (5.5.0-7) unstable; urgency=medium

  * Adjust depends to match cwltool 3.1.20211104071347 or greater.

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 07 Nov 2021 15:44:06 +0100

toil (5.5.0-6) unstable; urgency=medium

  * Support cwltool 3.1.20211104071347.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 05 Nov 2021 17:24:21 +0100

toil (5.5.0-5) unstable; urgency=medium

  * Another adjustment of disk/memory defaults for the autopkgtests.
  * debian/patches/exit_code_exception: Fix exception checking for
    exit_code

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 08 Oct 2021 10:57:25 +0200

toil (5.5.0-4) unstable; urgency=medium

  * Adjust disk/memory defaults further downward for 32-bit systems.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 06 Oct 2021 16:29:06 +0200

toil (5.5.0-3) unstable; urgency=medium

  * toil binary package depedency on recent cwltool as well.
  * Autopkgtests: skip collection of s3 tests

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 03 Oct 2021 13:20:18 +0200

toil (5.5.0-2) unstable; urgency=medium

  * Correct minimum versions for cwltool, python3-boto3

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 30 Sep 2021 11:42:30 +0200

toil (5.5.0-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * d/p/python3: adopted upstream
  * skipped networking-based tests
  * d/u/metadta: onfirmed missing registry entries

  [ Michael R. Crusoe ]
  * New upstream version
  * Refresh patches
  * Bump minimum version of cwltool needed to 3.1.20210922203925
  * Testing: ignore src/toil/test/lib/aws/test_s3.py
  * Add testing dependency on python3-yaml.
  * debian/patches/spelling: fix some typos
  * debian/toil.lintian-overrides: documented another false positive

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 29 Sep 2021 20:36:37 +0200

=== debian/control ===
--- 
+++ 
@@ -6,25 +6,26 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-python,
-               python3-all,
+               python3-all:any,
                python3-setuptools,
                python3-docker,
                python3-dill,
                python3-future,
-               cwltool (>= 3.0.20201203173111),
+               cwltool (>= 3.1.20211104071347),
                python3-distutils,
                python3-enlighten,
                python3-wdlparse,
                python3-pytest <!nocheck>,
                python3-mock <!nocheck>,
-               python3-boto3 <!nocheck>,
+               python3-boto3 (>=1.17) <!nocheck>,
                python3-boto <!nocheck>,
                python3-stubserver <!nocheck>,
                rsync <!nocheck>,
+               python3-yaml <!nocheck>,
 # documentation
                python3-urllib3,
                python3-sphinx
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
 Homepage: https://github.com/BD2KGenomics/toil
@@ -35,7 +36,7 @@
 Depends: ${python3:Depends},
          ${misc:Depends},
          python3-distutils,
-         cwltool
+         cwltool (>= 3.1.20211104071347)
 Recommends: python3-boto,
             python3-boto3,
 # for WDL support

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	PYBUILD_SYSTEM=custom \
-		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py -k "not test_bioconda and not test_run_conformance and not testImportFtpFile and not ToilWdlIntegrationTest and not SortTest and not testCwlexample" {dir}/src/toil/test' \
+		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py -k "not test_bioconda and not test_run_conformance and not testImportFtpFile and not ToilWdlIntegrationTest and not SortTest and not testCwlexample" {dir}/src/toil/test' \
 		dh_auto_test
 endif

=== debian/tests/control ===
Tests: smoke-test
Depends: toil, python3-wdlparse
Restrictions: superficial

Tests: run-unit-tests
Depends: toil, python3-wdlparse, python3-pytest, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml
Restrictions: allow-stderr, needs-internet

## toil 5.6.0

=== Makefile ===
--- 
+++ 
@@ -96,9 +96,11 @@
 	pip install -e .$(extras) $(packages)
 
 clean_develop: check_venv
-	- pip uninstall -y toil
 	- rm -rf src/*.egg-info
 	- rm src/toil/version.py
+
+uninstall:
+	- pip uninstall -y toil
 
 sdist: dist/$(sdist_name)
 
@@ -116,25 +118,21 @@
 	- rm -rf dist
 	- rm src/toil/version.py
 
-# We always claim to be Travis, so that local test runs will not skip Travis tests.
 # Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
 test: check_venv check_build_reqs
-	TRAVIS=true TOIL_OWNER_TAG="shared" \
+	TOIL_OWNER_TAG="shared" \
 	    python -m pytest --durations=0 --log-level DEBUG --log-cli-level INFO -r s $(cov) $(tests)
 
 
 # This target will skip building docker and all docker based tests
-# these are our travis tests; rename?
 test_offline: check_venv check_build_reqs
 	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
 	TOIL_SKIP_DOCKER=True \
-	TRAVIS=true \
-	    python -m pytest -vv --timeout=530 --log-level DEBUG --log-cli-level INFO $(cov) $(tests)
+	    python -m pytest -vv --timeout=600 --log-level DEBUG --log-cli-level INFO $(cov) $(tests)
 
 ifdef TOIL_DOCKER_REGISTRY
 
 docker_image:=$(TOIL_DOCKER_REGISTRY)/$(TOIL_DOCKER_NAME)
-
 grafana_image:=$(TOIL_DOCKER_REGISTRY)/toil-grafana
 prometheus_image:=$(TOIL_DOCKER_REGISTRY)/toil-prometheus
 mtail_image:=$(TOIL_DOCKER_REGISTRY)/toil-mtail
@@ -155,7 +153,7 @@
 
 	@set -ex \
 	; cd docker \
-	; docker build --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile .
+	; docker buildx build --platform linux/amd64,linux/arm64 --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile .
 
 	@set -ex \
 	; cd dashboard/prometheus \
@@ -168,7 +166,6 @@
 	@set -ex \
 	; cd dashboard/mtail \
 	; docker build --tag=$(mtail_image):$(TOIL_DOCKER_TAG) -f Dockerfile .
-
 
 docker/$(sdist_name): dist/$(sdist_name)
 	cp $< $@
@@ -182,7 +179,7 @@
 
 push_docker: docker
 	# Weird if logic is so we fail if all the pushes fail
-	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(docker_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
+	cd docker ; for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker buildx build --platform linux/amd64,linux/arm64 --push --tag=$(docker_image):$(TOIL_DOCKER_TAG) -f Dockerfile . && break || sleep 60; done
 	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(grafana_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
 	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(prometheus_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
 	for i in $$(seq 1 6); do if [[ $$i == "6" ]] ; then exit 1 ; fi ; docker push $(mtail_image):$(TOIL_DOCKER_TAG) && break || sleep 60; done
@@ -252,9 +249,18 @@
 mypy:
 	$(CURDIR)/contrib/admin/mypy-with-ignore.py
 
+pydocstyle_report.txt: src/toil
+	pydocstyle setup.py $^ > $@ 2>&1 || true
+
+diff_pydocstyle_report: pydocstyle_report.txt
+	diff-quality --compare-branch=master --violations=pycodestyle --fail-under=100 $^
+
 diff_mypy:
 	mypy --cobertura-xml-report . src/toil || true
 	diff-cover --fail-under=100 cobertura.xml
+
+pyupgrade: $(PYSOURCES)
+	pyupgrade --exit-zero-even-if-changed --py36-plus $^
 
 flake8: $(PYSOURCES)
 	flake8 --ignore=E501,W293,W291,E265,E302,E722,E126,E303,E261,E201,E202,W503,W504,W391,E128,E301,E127,E502,E129,E262,E111,E117,E306,E203,E231,E226,E741,E122,E251,E305,E701,E222,E225,E241,E305,E123,E121,E703,E704,E125,E402 $^

=== requirements.txt ===
dill>=0.3.2, <0.4
requests>=2, <3
docker>=3.7.2, <6
python-dateutil
psutil >= 3.0.1, <6
py-tes>=0.4.2,<1
addict>=2.2.1, <2.5
pytz>=2012
enlighten>=1.5.2, <2
typing-extensions ; python_version < '3.8'

=== debian/changelog ===
toil (5.6.0-1) unstable; urgency=medium

  * New upstream version
  * Refresh patches, retiring cwl_test_path, spelling, and
    test_with_less_memory
  * Skip the py-tes dependency for now.
  * Skip testVirtualEnv 

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Jan 2022 14:23:52 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                python3-docker,
                python3-dill,
                python3-future,
-               cwltool (>= 3.1.20211104071347),
+               cwltool (>= 3.1.20220119140128),
                python3-distutils,
                python3-enlighten,
                python3-wdlparse,

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	PYBUILD_SYSTEM=custom \
-		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py -k "not test_bioconda and not test_run_conformance and not testImportFtpFile and not ToilWdlIntegrationTest and not SortTest and not testCwlexample" {dir}/src/toil/test' \
+		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/toilwdlTest.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv)" {dir}/src/toil/test' \
 		dh_auto_test
 endif

=== debian/tests/control ===
Tests: smoke-test
Depends: toil, python3-wdlparse
Restrictions: allow-stderr, superficial

Tests: run-unit-tests
Depends: toil, python3-wdlparse, python3-pytest, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml
Restrictions: allow-stderr, needs-internet

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

https://github.com/BD2KGenomics/toil/releases .*/releases/@ANY_VERSION@@ARCHIVE_EXT@
